from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

from math import *

import sys


#INTENDED USAGE: keyboard.attach_listener(key, self.handler_method)



special_key_observers = {}
ordinary_key_observers = {}

class Keyboard(object):
    
    def keyboard_init():
        
        Keyboard.init_glut_handlers()
        
    keyboard_init = staticmethod(keyboard_init) 
        
    def init_glut_handlers():
        glutSpecialFunc(Keyboard.special_handler)
        glutKeyboardFunc(Keyboard.ordinary_handler)
    
    init_glut_handlers = staticmethod(init_glut_handlers) 
    
    def special_handler(key, x, y):
        
        
        if special_key_observers.has_key(key):
            for handler_func in special_key_observers[key]:
                handler_func()
        
    special_handler = staticmethod(special_handler) 
        
        
    def ordinary_handler(key, x, y):
        
        if ordinary_key_observers.has_key(key):
            for handler_func in ordinary_key_observers[key]:
                handler_func()
        
            
    ordinary_handler = staticmethod(ordinary_handler)       
            
            
    def attach_key_listener(key, function):
        
        const = 0
        if len(key) > 1:
            key_const_string = "GLUT_KEY_" + key.upper()
            
            exec "const = " + key_const_string
            
            
            if special_key_observers.has_key(const):
                special_key_observers[const] += [function]
            else:
                special_key_observers[const] = [function]
                
        else:
            
            
            if ordinary_key_observers.has_key(key):
                
                ordinary_key_observers[key] += [function]
            else:
                ordinary_key_observers[key] = [function]
            
    attach_key_listener = staticmethod(attach_key_listener)    
            
            
            
            
            