
from random import *
from keyboard import *
from bvhparser import *
from filenames import *

class QuizMaster(object):
    def __init__(self, fv1, fv2, testv, candidate = "Testing"):
        
        self.name = candidate
        
        self.figure_views = (fv1, fv2)
        self.test_view = testv
        
        
        
        self.test_filenames = ["walk.bvh"]
        self.test_finished = False
        seed()
        fv1.DisplayInfo = False
        fv2.DisplayInfo = False
        
        Keyboard.attach_key_listener("a", self.top_is_fake)
        Keyboard.attach_key_listener("z", self.bottom_is_fake)
        
        self.tests = []
        self.make_test_figures()
        
        self.current_test = 0
        
        self.next_question()
        
        
    
    def make_test_figures(self):
        
        parser = BvhParser()
        
        for orig_file in self.test_filenames:
            orig_figure = parser.parse(orig_file)
            
            compressed_figure_list = []
            
            for i in range(20):
                
                percent = i * 5
                
                
                filename = Filenames.compressed_filename_string(orig_file, percent)
                
                fig = parser.parse(filename)
                
                compressed_figure_list.append((str(percent), fig))
                
            
            shuffle(compressed_figure_list)
            
            self.tests.append((orig_figure, compressed_figure_list))
            
        
    
    def top_is_fake(self):
        if not self.test_finished:
            self.output_to_log(self.fake_at_top)
            self.next_question()
        
    def bottom_is_fake(self):
        if not self.test_finished:
            self.output_to_log(not self.fake_at_top)
            self.next_question()
        
    def next_question(self):
        
        while (True):
            ctest = self.tests[self.current_test]
            fakes = ctest[1]
            
            if len(fakes) > 0:
                break
            
            self.current_test += 1
            
            if self.current_test >= len(tests):
                #test is finished, exit crudely
                sys.exit()
            
        
        
        real_fig = ctest[0]
        
        fake_fig_entry = fakes.pop()
        fake_fig = fake_fig_entry[1]
        self.current_percentage = fake_fig_entry[0]
        
        
        self.fake_at_top = choice((True,False))
        
        if self.fake_at_top:
            self.figure_views[0].change_figure(fake_fig)
            self.figure_views[1].change_figure(real_fig)
        else:
            self.figure_views[1].change_figure(fake_fig)
            self.figure_views[0].change_figure(real_fig)
            
        self.test_view.Text = "Spot the fake: 'a' for top, 'z' for bottom"
        
        
        
        
        
        
        
        
    def output_to_log(self, correct):
        print self.current_percentage
        log_file = open("../testresultslog.txt", "a")
        log_file.write(self.name + '\t' + self.test_filenames[self.current_test] + '\t' + self.current_percentage + '\t' + str(correct) + '\n')
        log_file.close()
        
        
     
     
     
     
        
    
        