from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *

from math import *

import sys


from viewport import *
from notifiers import *
from quizmaster import *


class Window(object):
    def __init__(self, x = 600, y = 600, title = "Animation Window"):
        
        self.viewports = []
        
        self.dimensions_init(x, y)
        
        self.glut_window_init(title)
        self.viewports_init()
        
        
    def dimensions_init(self,x,y):
        self.x = x
        self.y = y
        
        
    def viewports_init(self):
        
        pass
        
        
        
        
        
    def set_viewports(self, viewports_list):
        self.viewports = viewports_list
        self.size_viewports()
        
        
    def size_viewports(self):
        #everything is full width
        
        height_available = self.y
        autosize_component_count = 0
        
        
        
        for v in self.viewports:
            
            
            v.x = self.x
            if not v.AutoSize:
                
                height_available -= v.y
            else:
                autosize_component_count += 1
                
            
           
             
        if autosize_component_count > 0:
            height_available = height_available / autosize_component_count
        
        
        
        for v in self.viewports:
            if v.AutoSize:
                v.y = height_available
        
            
        
    def glut_window_init(self, title):
        
        glutInitWindowSize (self.x, self.y); 
        glutInitWindowPosition (100, 100);
        
        glutCreateWindow(title);
         
        
    def get_x(self):
        return self.x_val
    
    def set_x(self, x):
        self.x_val = x
    
    
    
    def get_y(self):
        return self.y_val
    
    def set_y(self, y):
        self.y_val = y
        
    x = property(get_x, set_x)
    y = property(get_y, set_y)
        
        
    
    
    
    
    def resize(self,x,y):
        pass
    
    
    
    
        
    def display(self):
       
        y_offset = 0
        
        
        for viewport in self.viewports:
            
            viewport.display(self.y, y_offset)
            y_offset += viewport.y
            
        
    
    
    
    
    
class AnalysisWindow(Window):
    
        
    def viewports_init(self):
    
        
        g1 = GraphViewport()
        g2 = GraphViewport()
        g3 = GraphViewport()
        
        
        graph_collection_view = GraphCollectionViewport(self.x)
        graph_collection_view.add_graph_viewports([g1, g2, g3])
        
        
        
        bvh_parser = BvhParser()
        figure = bvh_parser.parse("walk.bvh")
        
        
        fig_view = FigureViewport(figure)
        
        
        fig_view.hookup_joint_observer(graph_collection_view)
        fig_view.hookup_frame_observer(graph_collection_view)
        
        self.set_viewports([fig_view, graph_collection_view])
    
    
    
    
    
    
class QuizWindow(Window):
    
        
    
    
    
    def viewports_init(self):
        
        bvh_parser = BvhParser()
        figure = bvh_parser.parse("walk.bvh")
        
        
        figure2 = bvh_parser.parse("walk.bvh")
        
        
        fig_view = FigureViewport(figure)
        
        fig_view2 = FigureViewport(figure2)
        
        quizdisplayview = QuizViewport()
        
        
        quizo = QuizMaster(fig_view, fig_view2, quizdisplayview)
        
        
        
        self.set_viewports([fig_view, fig_view2, quizdisplayview])
        